// flat.h procedure per poligoni flat by Bellotti Stefano 4/1/97
// VERSIONE MIGLIORATA
// Apparentemente esente da bug
// occhio all'angolo in basso a destra se il buffer e' di esattamente 64K

void draw_face (int x1,int y1,int x2,int y2,int x3,int y3,char col,char far *buffer);
// Disegna un poligono (triangolare) clippato rispetto ad un buffer di 320x200

void draw_line(int x1,int y1,int x2,int y2,unsigned int a[],int *pil,int *pih);



void draw_face (int x1,int y1,int x2,int y2,int x3,int y3,char col,char far *buffer)
{
 int i,aus,a1,b1,start_pos,end_pos,il,ih,il1,ih1,il2,ih2;
 unsigned int a[255],b[255],ind;


 //Eliminazione poligoni esterni

 if(x1<0 && x2<0 && x3<0) return 0;
 if(x1>319 && x2>319 && x3>319) return 0;

 //Ordinamento y

 if(y1>y2)
 {
  aus=y1;
  y1=y2;
  y2=aus;
  aus=x1;
  x1=x2;
  x2=aus;
 }
 if(y2>y3)
 {
  aus=y2;
  y2=y3;
  y3=aus;
  aus=x2;
  x2=x3;
  x3=aus;
 }
 if(y1>y2)
 {
  aus=y1;
  y1=y2;
  y2=aus;
  aus=x1;
  x1=x2;
  x2=aus;
 }

 //Clipping orizzontale

 start_pos=0;
 end_pos=y3-y1;
 if(y1<0)
 {
  if(y3<0) return 0;
  start_pos=-y1;
 }
 if(y3>199)
 {
  if(y1>199) return 0;
  if(end_pos>199-y1) end_pos=199-y1;
 }

 //Calcolo delle linee congiungenti i vertici

 il1=ih1=1000;
 il2=ih2=-1000;
 il=ih=0X7FFF;
 draw_line(x1,y1,x2,y2,b,&il,&ih);
 if(il!=0X7FFF) il1=il2=il;
 if(ih!=0X7FFF) ih1=ih2=ih;

 il=ih=0X7FFF;
 draw_line(x2,y2,x3,y3,&b[y2-y1],&il,&ih);
 if(il!=0X7FFF)
 {
  il+=y2-y1;
  if(il<il1) il1=il;
  if(il>il2) il2=il;
 }
 if(ih!=0X7FFF)
 {
  ih+=y2-y1;
  if(ih<ih1) ih1=ih;
  if(ih>ih2) ih2=ih;
 }

 il=ih=0X7FFF;
 draw_line(x3,y3,x1,y1,a,&il,&ih);
 if(il!=0X7FFF)
 {
  if(il<il1) il1=il;
  if(il>il2) il2=il;
 }
 if(ih!=0X7FFF)
 {
  if(ih<ih1) ih1=ih;
  if(ih>ih2) ih2=ih;
 }

 // Ora il1=posizione nell'array dell'uscita superiore dal bordo sinistro
 //     il2=                                 inferiore           sinistro
 //     ih1=                                 superiore           destro
 //     ih2=                                 inferiore           destro

 //Eliminazione facce esterne

 if(x3<0 && il2<start_pos) return(0);
 if(x3>319 && ih2<start_pos) return(0);
 if(x1<0 && il1>end_pos) return(0);
 if(x1>319 && ih1>end_pos) return(0);

 // Ordinamento: a=array sinisto b=array destro

 for(i=start_pos;i<=end_pos;i++)
 {
  if(a[i]>b[i])
  {
   aus=a[i];
   a[i]=b[i];
   b[i]=aus;
  }
 }
 if(y1<=0)
 {
  if(b[start_pos]>320 && a[start_pos]<320) b[start_pos]=a[start_pos];
 }

 //Clipping sinistro

 if((x1<0 || x2<0 || x3<0) && il2>=start_pos && il1<=end_pos)
 {
  if(x1<0 && start_pos<il1) start_pos=il1;
  if(x3<0 && end_pos>il2) end_pos=il2;

  if(il1<start_pos)
  {
   il1=start_pos; // Si clippa solo la parte nello schermo
   //b[il1]=a[il1]; // Se il1<start_pos a[il1] contiene un valore negativo, quindi, nel ciclo precedente a NON e' stato scambiato con b
  }

  if(il2>end_pos) il2=end_pos;

  ind=((il1+y1)<<8)+((il1+y1)<<6);
  a[il1]=ind;
  if(b[il1]<ind) b[il1]=ind;

  if(il1!=il2)
  {
   for(i=il1+1;i<il2;i++)
   {
    ind+=320;
    a[i]=ind;
   }
   a[il2]=ind+320;
   if(b[il2]<ind+320) b[il2]=ind+320;
  }
 }

 //Clipping destro

 if((x1>319 || x2>319 || x3>319) && ih2>=start_pos && ih1<=end_pos)
 {
  if(x1>319 && start_pos<ih1) start_pos=ih1;
  if(x3>319 && end_pos>ih2) end_pos=ih2;

  if(ih1<start_pos) ih1=start_pos;
  if(ih2>end_pos) ih2=end_pos;

  ind=((ih1+y1)<<8)+((ih1+y1)<<6)+319;
  b[ih1]=ind;
  if(a[ih1]>ind) a[ih1]=ind;

  if(ih1!=ih2)
  {
   for(i=ih1+1;i<ih2;i++)
   {
    ind+=320;
    b[i]=ind;
   }
   b[ih2]=ind+320;
   if(a[ih2]>ind+320) a[ih2]=ind+320;
  }
 }

 //Filling

 asm mov ax,WORD PTR [buffer+2]
 asm mov es,ax
 asm cld
 for(i=start_pos;i<=end_pos;i++)
 {
  a1=a[i];
  b1=b[i];
  asm mov di,WORD PTR [buffer]
  asm add di,a1
  asm mov cx,b1
  asm sub cx,a1
  asm inc cx
  asm mov al,col
  asm rep stosb
 }
}


void draw_line(int x1,int y1,int x2,int y2,unsigned int a[],int *pil,int *pih)
{
 int d,dx,dy,dx1;
 int aincr,bincr,indincr,iincr;
 int x,y,xold;
 int aus,i;
 signed char indincr2;
 unsigned int ind;

 if(y1==y2)	//Linea orizzontale
 {
  a[0]=(y1<<8)+(y1<<6)+x1;
  if((x1<0 && x2>=0) || (x1>=0 && x2<0)) *pil=0;
  if((x1>319 && x2<=319) || (x1<=319 && x2>319)) *pih=0;
 }
 else
 {
  if(x1==x2)  //Linea verticale
  {
   if(y1>y2)
   {
    aus=y1;
    y1=y2;
    y2=aus;
   }
   ind=(y1<<8)+(y1<<6)+x1;
   for(i=0;i<=y2-y1;i++,ind+=320) a[i]=ind;
  }
  else
  {
   if(abs(x2-x1)>=abs(y2-y1))	//coeff. ang.<=1
   {
    if(x1>x2)
    {
     aus=x1;
     x1=x2;
     x2=aus;
     aus=y1;
     y1=y2;
     y2=aus;
    }

    if(y2>y1)
    {
     indincr=320;
     iincr=1;
     i=0;
    }
    else
    {
     indincr=-320;
     iincr=-1;
     i=y1-y2;
    }

    dx=x2-x1;
    dy=abs(y2-y1);
    d=(dy<<1)-dx;
    aincr=(dy-dx)<<1;
    bincr=dy<<1;
    x=x1;
    y=y1;

    ind=(y<<8)+(y<<6)+x;
    a[i]=ind;
    if(x==0) *pil=i;
    if(x==319) *pih=i;

    for(x=x1+1;x<=x2;x++)
    {
     ind++;
     if(d>=0)
     {
      ind+=indincr;
      i+=iincr;
      d+=aincr;
     }
     else d+=bincr;
     a[i]=ind;
     if(x==0) *pil=i;
     if(x==319) *pih=i;
    }
   }
   else // coeff ang. >1
   {
    if(y1>y2)
    {
     aus=x1;
     x1=x2;
     x2=aus;
     aus=y1;
     y1=y2;
     y2=aus;
    }

    dy=y2-y1;
    dx=abs(x2-x1);
    if(x2>x1) indincr=1;
    else indincr=-1;
    //indincr2+=320;

    d=(dx<<1)-dy;
    aincr=(dx-dy)<<1;
    bincr=dx<<1;

    ind=(y1<<8)+(y1<<6)+x1;
    a[0]=ind;
    x=x1;
    i=0;
    if(x==0) *pil=i;
    if(x==319) *pih=i;

    for(y=y1+1;y<=y2;y++)
    {
     ind+=320;
     i++;
     if(d>=0)
     {
      ind+=indincr;
      x+=indincr;
      d+=aincr;
      if(x==0) *pil=i;
      if(x==319) *pih=i;
     }
     else d+=bincr;
     //draw_pixel(ind,col);  //for debugging
     a[i]=ind;
    }
   }
  }
 }
}
